diff --git a/lib/hive/commands/migrate.rb b/lib/hive/commands/migrate.rb
index 695cb4f..8bceb6c 100644
--- a/lib/hive/commands/migrate.rb
+++ b/lib/hive/commands/migrate.rb
@@ -38,7 +38,7 @@ module Hive
       end
 
       def call
-        hive_state = File.join(@project_path, ".hive-state")
+        hive_state = File.join(@project_path, ProjectDirs.resolve(@project_path))
         stages = File.join(hive_state, "stages")
         raise Hive::InvalidTaskPath, "not a hive project: #{hive_state}" unless Dir.exist?(stages)
 
diff --git a/lib/hive/commands/prune.rb b/lib/hive/commands/prune.rb
index c91f02d..f503456 100644
--- a/lib/hive/commands/prune.rb
+++ b/lib/hive/commands/prune.rb
@@ -4,7 +4,7 @@ require "hive/config"
 module Hive
   module Commands
     # `hive prune [--dry-run] [--json]` — drop every registry entry in
-    # ~/Dev/hive/config.yml whose `path` no longer points at a directory.
+    # ~/.config/hive/config.yml whose `path` no longer points at a directory.
     # Also drops malformed entries (non-Hash rows, rows missing `path`,
     # rows whose `path` isn't a String) — these are hand-edit accidents
     # and have always been undisplayable in `hive status`. The
@@ -82,7 +82,7 @@ module Hive
         elsif abs_path.empty?
                        ""
         else
-                       File.join(abs_path, ".hive-state")
+                       File.join(abs_path, ProjectDirs.resolve(abs_path))
         end
         {
           "name" => entry["name"].to_s,
diff --git a/lib/hive/commands/status.rb b/lib/hive/commands/status.rb
index d777528..062d7df 100644
--- a/lib/hive/commands/status.rb
+++ b/lib/hive/commands/status.rb
@@ -262,7 +262,7 @@ module Hive
         end
         hive_state = project["hive_state_path"]
         unless File.directory?(hive_state)
-          puts "#{project['name']}: not initialised (no .hive-state)"
+          puts "#{project['name']}: not initialised (no #{Hive::PROJECT_DIR} scaffold)"
           return
         end
 
diff --git a/lib/hive/commands/uninstall.rb b/lib/hive/commands/uninstall.rb
new file mode 100644
index 0000000..f81b0d6
--- /dev/null
+++ b/lib/hive/commands/uninstall.rb
@@ -0,0 +1,317 @@
+require "fileutils"
+require "hive/install_receipt"
+require "hive/service"
+
+module Hive
+  module Commands
+    # `hive uninstall` — conservative, preserve-by-default removal
+    # (plan figure-out-way-to-install-260513-4a0a U7 / R15 / scenario D).
+    #
+    # Categories (in this order):
+    #   1. daemon service registration — ALWAYS removed.
+    #   2. project `.hive/` directories (per registered project) — offered
+    #      one by one, DEFAULT KEEP. Accumulated work is never destroyed
+    #      without an explicit opt-in, and `--purge` still preserves it
+    #      (CI-friendly subset only touches registrations + receipt).
+    #   3-5. global data (~/.config/hive + ~/.local/state/hive +
+    #        ~/.cache/hive) — one combined prompt, DEFAULT KEEP.
+    #
+    # The BINARY itself is owned by the package manager, so its removal is
+    # delegated to the channel recorded in the install receipt (brew
+    # uninstall / pacman -Rns / local script reversal). Skills are never
+    # touched here: they are removed via each agent's own marketplace
+    # (printed pointer below).
+    #
+    # Non-TTY semantics:
+    #   plain            → prints the action plan, changes NOTHING, exit 0
+    #   --purge          → deterministic subset: service teardown +
+    #                      registry tidy (prune predicate semantics) +
+    #                      receipt removal; work/data PRESERVED.
+    class Uninstall
+      GITHUB_REPO = "ivankuznetsov/hive".freeze
+
+      attr_reader :receipt
+
+      def initialize(purge: false, input: $stdin, out: $stdout, err: $stderr,
+                     runner: ->(*argv) { Open3.capture3(*argv) })
+        @purge = purge
+        @input = input
+        @out = out
+        @err = err
+        @runner = runner
+        @actions = []
+      end
+
+      def call
+        data, source = Hive::InstallReceipt.resolve(resolved_binary_path)
+        @receipt = data
+        @channel = source
+
+        note_header
+        remove_service!
+        tidy_registry_and_receipt!
+        collect_binary_delegation!
+
+        if tty?
+          offer_project_removals!
+          offer_global_data_removal!
+        else
+          if @purge
+            apply_project_tidy_only!
+          else
+            print_plan_and_exit_untouched!
+          end
+        end
+        print_skills_pointer
+
+        summary_line
+        0
+      end
+
+      # Name used across every lifecycle message — honors the Apache-Hive
+      # collision fallback (`hv`) recorded at install time (R13/R16).
+      def self.command_name
+        ENV["HIVE_COMMAND_NAME"] ||
+          (r = begin
+                 Hive::InstallReceipt.read&.fetch("command_name")
+               rescue StandardError
+                 nil
+               end) ||
+          "hive"
+      end
+
+      def command_name
+        self.class.command_name
+      end
+
+      private
+
+      def tty?
+        @input.respond_to?(:tty?) && @input.tty?
+      end
+
+      def resolved_binary_path
+        name = command_name
+        ENV.fetch("PATH", "").split(File::PATH_SEPARATOR)
+           .map { |d| File.join(d, name) }
+           .find { |p| File.file?(p) }
+      end
+
+      def note_header
+        @out.puts "#{command_name} uninstall — plan:"
+        @out.puts "  1. daemon service registration (always)"
+        @out.puts "  2. project .hive scaffolds (per project, default keep)"
+        @out.puts "  3. global data ~/.config / state / cache dirs (default keep)"
+        @out.puts "  4. binary removal — delegated to your install channel"
+      end
+
+      def step(label)
+        @actions << label
+      end
+
+      # ── Category 1: service ────────────────────────────────────────────
+
+      def remove_service!
+        require "hive/service"
+        manager_calls.clear
+        unloaded = begin
+          Hive::Service.unload!
+        rescue StandardError
+          false
+        end
+        manifest_gone = Hive::Service.remove_manifest!
+        if unloaded || manifest_gone
+          step("remove daemon service registration")
+          @out.puts "  ✓ removed daemon service registration"
+        else
+          @out.puts "  · no daemon service registration found"
+        end
+      rescue StandardError => e
+        warn("service teardown problem (continuing): #{e.class}: #{e.message}")
+      end
+
+      def manager_calls
+        @manager_calls ||= []
+      end
+
+      # ── Category 2 helpers ─────────────────────────────────────────────
+
+      def projects
+        Hive::Config.registered_projects
+      rescue Hive::ConfigError
+        []
+      end
+
+      def offer_project_removals!
+        list = projects
+        if list.empty?
+          @out.puts "  · no registered projects"
+          return
+        end
+
+        list.each do |p|
+          scaffold = p["hive_state_path"]
+          next unless scaffold && File.directory?(scaffold)
+
+          answer = ask("#{command_name} uninstall: remove project '#{p['name']}' scaffold #{scaffold}? [keep/remove]")
+          next unless answer == "remove"
+
+          FileUtils.rm_rf(scaffold)
+          # Registry rows whose path no longer exists are prunable via the
+          # existing predicate semantics; drop this row directly too.
+          forget_row = Hive::Config.unregister_project(name: p["name"])
+          step("remove project #{p['name']} scaffold")
+          @out.puts "  ✓ removed #{scaffold}#{forget_row ? ' + registry row' : ''}"
+        end
+      end
+
+      def apply_project_tidy_only!
+        result = Hive::Config.prune_missing_projects!(dry_run: false)
+        step("tidy registry") unless result[:removed].empty?
+        @out.puts "  · --purge keeps all project data (#{result[:kept_count]} registries kept)"
+      end
+
+      # Receipt lives inside the config home, so plain interactive
+      # uninstall removes it together with category 3; --purge always does.
+      def tidy_registry_and_receipt!
+        return unless @purge
+
+        Hive::InstallReceipt.forget!
+        step("forget install receipt")
+        @out.puts "  ✓ forgot install receipt (work data preserved)"
+      end
+
+      # ── Categories 3–5: global data ────────────────────────────────────
+
+      GLOBAL_DATA_DIRS = [
+        -> { Hive::Paths.config_dir },
+        -> { Hive::Paths.state_dir },
+        -> { Hive::Paths.cache_dir }
+      ].freeze
+
+      def offer_global_data_removal!
+        answer = ask("Remove global data (config/state/cache under #{Hive::Paths.config_dir}, " \
+                     "#{Hive::Paths.state_dir}, #{Hive::Paths.cache_dir})? [y/N]")
+        return unless %w[y yes].include?(answer)
+
+        GLOBAL_DATA_DIRS.each do |dir_block|
+          dir = dir_block.call.to_s
+          FileUtils.rm_rf(dir) if !dir.empty? && File.directory?(dir)
+        end
+        Hive::InstallReceipt.forget!
+        step("remove global data dirs + receipt")
+        @out.puts "  ✓ removed global data (receipt included)"
+      end
+
+      # ── Binary delegation ──────────────────────────────────────────────
+
+      def collect_binary_delegation!
+        channel, cmd = binary_delegation_command
+        if channel == :script && @channel != :none && @receipt &&
+           ((@receipt["channel"] == "script") || channel == :script)
+          delegate_script_inline!
+          return
+        end
+        if cmd.nil?
+          @out.puts "  · binary removal skipped (no package-manager ownership detected)"
+          return
+        end
+
+        step("delegate binary removal to #{channel}")
+        @out.puts "  → delegating to #{channel}: #{cmd.shelljoin}"
+        _out, err, status = @runner.call(*cmd)
+        if status && status.success?
+          @out.puts "  ✓ #{channel} removed the binary"
+        else
+          detail = err.to_s.strip.empty? ? "(no stderr)" : err.strip
+          warn("#{channel} could not remove the binary; finish manually with: #{cmd.shelljoin} (#{detail})")
+        end
+      end
+
+      # Script installs own their bits locally; reverse the PATH symlink(s)
+      # directly (never the data dirs — those are separate opt-ins above).
+      def delegate_script_inline!
+        name = command_name
+        removed = []
+        ENV.fetch("PATH", "").split(File::PATH_SEPARATOR).each do |dir|
+          link = File.join(dir, name)
+          target = begin
+            File.readlink(link)
+          rescue StandardError
+            nil
+          end
+          next unless target&.include?(Hive::Paths.data_dir)
+
+          FileUtils.rm_f(link)
+          removed << link
+        end
+        if removed.empty?
+          @out.puts "  · no script-managed launcher found on PATH"
+        else
+          step("remove script-installed launcher(s)")
+          @out.puts "  ✓ removed #{removed.join(', ')}"
+        end
+      end
+
+      # Returns [channel_symbol, argv] or [nil, nil].
+      def binary_delegation_command
+        return [ nil, nil ] if @channel == :none || @receipt.nil?
+
+        receipt_channel = @receipt["channel"]
+        if receipt_channel == "script" || @channel == :detected_script
+          return [ :script, nil ] # handled inline via delegate_script_inline!
+        end
+
+        case @channel
+        when :receipt, :detected_brew
+          [ :brew, ["brew", "uninstall", "#{brew_user}/hive/hive"] ]
+        when :detected_aur
+          [ :aur, ["sudo", "pacman", "-Rns", "hive-bin"] ]
+        else
+          [ nil, nil ]
+        end
+      end
+
+      def brew_user
+        ENV["HIVE_BREW_TAP"] || "ivankuznetsov"
+      end
+
+      # ── Messaging ──────────────────────────────────────────────────────
+
+      def print_plan_and_exit_untouched!
+        @out.puts ""
+        @out.puts "Non-interactive shell and no --purge: nothing has been changed."
+        @out.puts "Re-run with --purge for the deterministic CI-safe subset " \
+                   "(service + receipt; all project/global work preserved),"
+        @out.puts "or run interactively on a TTY to choose per-category removal."
+        @unchanged = true
+      end
+
+      def print_skills_pointer
+        @out.puts ""
+        @out.puts "Skills are intentionally NOT removed by this command."
+        @out.puts "  Uninstall them from each agent CLI's marketplace/plugin UI instead."
+      end
+
+      def summary_line
+        @out.puts ""
+        if @actions.empty?
+          @out.puts "Done. Nothing was modified." if @unchanged
+        else
+          @out.puts "Done. Performed #{@actions.size} change(s)."
+          @actions.each { |a| @out.puts "  - #{a}" }
+        end
+      end
+
+      def ask(question)
+        @out.print "#{question}: "
+        @out.flush
+        (@input.gets || "").strip.downcase
+      end
+
+      def warn(line)
+        @err.puts line
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/update.rb b/lib/hive/commands/update.rb
new file mode 100644
index 0000000..7102919
--- /dev/null
+++ b/lib/hive/commands/update.rb
@@ -0,0 +1,141 @@
+require "open3"
+require "shellwords"
+require "hive/install_receipt"
+
+module Hive
+  module Commands
+    # `hive update` — channel-aware updater (plan
+    # figure-out-way-to-install-260513-4a0a U6 / R14).
+    #
+    # The binary is OWNED by whichever distribution channel installed it.
+    # This command NEVER swaps a binary in place; it resolves the install
+    # receipt (~/.config/hive/install.yml, written by the brew formula /
+    # AUR .install hook / install.sh) and delegates to the channel's
+    # native upgrade mechanism:
+    #
+    #   brew   → brew upgrade ivankuznetsov/hive/hive
+    #   aur    → <yay|paru> -Syu hive-bin        (never plain `-S`)
+    #   script → re-run the pinned release install.sh
+    #
+    # Guards:
+    #   * refuses to run as root / under sudo (Risk #10: receipts are per-user)
+    #   * no receipt + no fallback detection = dev checkout: prints guidance
+    #     and exits 0 — nothing happens.
+    class Update
+      GITHUB_REPO = "ivankuznetsov/hive".freeze
+
+      # `runner` receives argv arrays and returns [out, err, status-like].
+      # Injectable for tests; production shells out via Open3.
+      def initialize(out: $stdout, err: $stderr,
+                     runner: ->(*argv) { Open3.capture3(*argv) })
+        @out = out
+        @err = err
+        @runner = runner
+      end
+
+      def call
+        refuse_sudo!
+        data, source = Hive::InstallReceipt.resolve
+
+        if source == :none || data.nil?
+          @out.puts "hive update: no package-manager receipt found."
+          @out.puts "  If this is a dev checkout, pull the branch and reinstall deps instead."
+          @out.puts "  Otherwise reinstall via your channel (brew / AUR hive-bin / install.sh)."
+          return 0
+        end
+
+        before = current_version_line
+        case data["channel"]
+        when "brew" then update_brew(data)
+        when "aur" then update_aur(data)
+        when "script" then update_script(data)
+        else
+          raise Hive::ConfigError,
+                "unknown install channel #{data['channel'].inspect} in #{Hive::InstallReceipt.path}"
+        end
+
+        after = current_version_line
+        @out.puts "hive update: done."
+        @out.puts "  before: #{before || 'unknown'}"
+        @out.puts "  after:  #{after || 'unknown'}"
+        0
+      end
+
+      private
+
+      def refuse_sudo!
+        return if Process.uid != 0 && Process.euid != 0
+        return if ENV["HIVE_ALLOW_ROOT_UPDATE"] == "1"
+
+        raise Hive::Error,
+              "refusing to run `hive update` as root/under sudo: the install receipt is per-user " \
+              "(#{Hive::InstallReceipt.path}); run it unprivileged. " \
+              "(Set HIVE_ALLOW_ROOT_UPDATE=1 only inside disposable CI containers.)"
+      end
+
+      def update_brew(_data)
+        tap_name = "#{ENV["HIVE_BREW_TAP"] || 'ivankuznetsov'}/hive/hive"
+        note "$ brew upgrade #{tap_name}"
+        run_or_fail!("brew", "upgrade", tap_name)
+      end
+
+      def update_aur(_data)
+        helper = %w[yay paru].find { |h| helper_available?(h) }
+        if helper.nil?
+          raise Hive::Error,
+                "no AUR helper found on PATH (looked for yay, paru); " \
+                "run manually: yay -Syu hive-bin"
+        end
+
+        note "$ #{helper} -Syu --needed hive-bin   (`-S` alone is deliberately never used)"
+        run_or_fail!(helper, "-Syu", "--needed", "hive-bin")
+      end
+
+      def update_script(data)
+        base = data["release_base"] || release_download_base(data["version"])
+        url = "#{base}/install.sh"
+        note "$ curl -fsSL #{url} | bash"
+        cmd = "curl -fsSL #{Shellwords.escape(url)} | " \
+              "HIVE_VERSION=#{Shellwords.escape(data['version'].to_s)} bash"
+        run_or_fail!("sh", "-c", cmd)
+      end
+
+      def release_download_base(version)
+        "https://github.com/#{GITHUB_REPO}/releases/download/#{version || 'latest'}"
+      end
+
+      def helper_available?(name)
+        out, _err, status = Open3.capture3("sh", "-c", "command -v #{Shellwords.escape(name)}")
+        status.success? && !out.to_s.strip.empty?
+      end
+
+      def run_or_fail!(*argv)
+        _out, err, status = @runner.call(*argv)
+        return if status&.success?
+
+        raise Hive::GitError,
+              "channel updater failed (#{argv.shelljoin}): " \
+              "#{err.to_s.strip.empty? ? '(no stderr)' : err.strip}"
+      end
+
+      def current_version_line
+        bin = found_command || "hive"
+        out, _err, status = Open3.capture3(bin, "--version")
+        status.success? ? out.lines.first.to_s.strip : nil
+      rescue StandardError
+        nil
+      end
+
+      def found_command
+        name = ENV["HIVE_COMMAND_NAME"] || "hive"
+        ENV.fetch("PATH", "").split(File::PATH_SEPARATOR)
+           .map { |d| File.join(d, name) }
+           .find { |p| File.file?(p) }
+      end
+
+      def note(line)
+        @out.puts line
+      end
+    end
+  end
+end
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index a67097d..4e881f3 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -1,11 +1,13 @@
 require "yaml"
 require "fileutils"
+require "hive"
 require "hive/agent_profiles"
+require "hive/paths"
 
 module Hive
   module Config
     DEFAULTS = {
-      "hive_state_path" => ".hive-state",
+      "hive_state_path" => ".hive", # canonical scaffold root (Hive::PROJECT_DIR)
       "worktree_root" => nil,
       "default_branch" => nil,
       "project_name" => nil,
@@ -158,8 +160,11 @@ module Hive
       },
       # Global Telegram bot settings. The bot is an operator surface
       # across every registered project, so runtime code loads these
-      # from ~/Dev/hive/config.yml via load_global_bot. The token lives
+      # from ~/.config/hive/config.yml via load_global_bot. The token lives
       # only in HIVE_TELEGRAM_BOT_TOKEN and is never persisted.
+      # The pid/log/last_seen defaults below are resolved at load time
+      # via Hive::Paths.bot_* (XDG state dir, or the HIVE_HOME sandbox
+      # layout); they are rendered as absolute paths by global_bot_defaults.
       "bot" => {
         "enabled" => false,
         "chat_id_allowlist" => [],
@@ -170,11 +175,11 @@ module Hive
         "codex_budget_usd" => 1,
         "codex_timeout_sec" => 120,
         "shutdown_grace_sec" => 60,
-        "pid_file" => "~/Dev/hive/.bot.pid",
-        "log_file" => "~/Dev/hive/logs/bot.log",
+        "pid_file" => nil,
+        "log_file" => nil,
         "log_max_bytes" => 10_485_760,
         "log_max_files" => 5,
-        "last_seen_state_file" => "~/Dev/hive/.bot.last_seen_update_id"
+        "last_seen_state_file" => nil
       },
       # Auto-rebase pre-step for `hive run` (plan
       # docs/plans/2026-05-14-001-feat-hive-auto-rebase-stale-worktree-plan.md).
@@ -209,21 +214,63 @@ module Hive
     module_function
 
     def hive_home
-      ENV["HIVE_HOME"] || File.expand_path("~/Dev/hive")
+      ENV["HIVE_HOME"] || Hive::Paths.config_dir
     end
 
     def global_config_path
+      migrate_legacy_config!
       File.join(hive_home, "config.yml")
     end
 
-    def hive_state_dir(project_root, hive_state_name = ".hive-state")
-      File.join(project_root, hive_state_name)
+    # Test-support hook: clears the once-per-process migration memo so
+    # each test exercises a fresh migration attempt.
+    def reset_migration_memo!
+      remove_instance_variable(:@legacy_config_migrated) if instance_variable_defined?(:@legacy_config_migrated)
+    end
+
+    # One-time migration from the pre-XDG layout where the ~/Dev/hive
+    # source checkout doubled as the config home. When running against
+    # the default XDG config home (i.e., HIVE_HOME is NOT set): if a
+    # legacy config.yml exists and no XDG one does yet, MOVE it (not
+    # copy — the checkout dir must not keep being read as truth) with a
+    # printed notice, then continue. Only ever runs once per process and
+    # never inside an explicit HIVE_HOME sandbox (tests / forced dev
+    # isolation), where the legacy dir is meaningless.
+    def migrate_legacy_config!
+      return if @legacy_config_migrated
+      return if ENV["HIVE_HOME"] && !ENV["HIVE_HOME"].empty?
+
+      @legacy_config_migrated = true
+      legacy = Hive::Paths.legacy_hive_home
+      legacy_config = File.join(legacy, "config.yml")
+      target = File.join(Hive::Paths.config_dir, "config.yml")
+      return unless File.file?(legacy_config)
+      return if File.exist?(target)
+
+      require "fileutils"
+      FileUtils.mkdir_p(Hive::Paths.config_dir)
+      FileUtils.mv(legacy_config, target)
+      warn "hive: migrated global config from #{legacy_config} to #{target} " \
+           "(the ~/Dev/hive layout is deprecated; your project registry moved with it)"
+    rescue Errno::EACCES, Errno::EXDEV, Errno::ENOENT => e
+      warn "hive: could not migrate legacy config #{legacy_config}: #{e.class}: #{e.message}"
+      # Non-fatal: a failed migration simply leaves both files in place;
+      # the loader will read whichever target exists (or none).
+    end
+
+    def hive_state_dir(project_root, hive_state_name = nil)
+      name = hive_state_name || ProjectDirs.resolve(project_root)
+      File.join(project_root, name)
     end
 
     def load(project_root)
       project_root = File.expand_path(project_root)
-      candidate = File.join(project_root, ".hive-state", "config.yml")
-      data = if File.exist?(candidate)
+      # Back-compat probe (plan U2): prefer the canonical `.hive/config.yml`,
+      # fall back to the legacy `.hive-state/config.yml` for pre-rename trees.
+      candidate = [PROJECT_DIR, LEGACY_PROJECT_DIR]
+                  .map { |d| File.join(project_root, d, "config.yml") }
+                  .find { |c| File.exist?(c) }
+      data = if candidate
                parsed = YAML.safe_load(File.read(candidate)) || {}
                raise ConfigError, "config.yml at #{candidate} must be a hash" unless parsed.is_a?(Hash)
 
@@ -232,7 +279,7 @@ module Hive
                {}
       end
       merged = merge_defaults(data).merge("project_root" => project_root)
-      validate!(merged, candidate)
+      validate!(merged, candidate || File.join(project_root, PROJECT_DIR, "config.yml"))
       merged
     end
 
@@ -275,7 +322,7 @@ module Hive
         out << {
           "name" => entry["name"],
           "path" => abs_path,
-          "hive_state_path" => entry["hive_state_path"] || File.join(abs_path, ".hive-state")
+          "hive_state_path" => normalize_registry_state_path(abs_path, entry["hive_state_path"])
         }
       end
     end
@@ -299,7 +346,7 @@ module Hive
     # same `error_kind: "config"` envelope the TUI's narrow rescue catches.
     #
     # EACCES specifically is the most user-facing of the IO group:
-    # `chmod 000 ~/Dev/hive/config.yml` (or running as a different
+    # `chmod 000 ~/.config/hive/config.yml` (or running as a different
     # user) used to surface as `internal error: Errno::EACCES: ...`
     # at exit 70. The root cause is configuration access, not a Hive
     # bug — exit 78 is the right shape.
@@ -311,15 +358,42 @@ module Hive
       raise ConfigError, "global config at #{path} is not readable: #{e.message}"
     end
 
-    # Atomic + EACCES-aware writer for ~/Dev/hive/config.yml. Mirrors
+    # Atomic + EACCES-aware writer for ~/.config/hive/config.yml. Mirrors
     # the shape of `Hive::Markers.write_atomic` so a future flock
     # upgrade (Issue #31) can swap in here without rewriting every
     # call site. Permission errors on write surface as ConfigError
     # (exit 78), matching the read-side classification.
+    # Atomic-ish writer for <config-home>/config.yml (default:
+    # ~/.config/hive/config.yml). The file holds the project registry and
+    # may sit next to operator-configured provider/model settings; it is
+    # always written mode 0600 so local users cannot read operator secrets.
     def write_global_config!(data)
-      File.write(global_config_path, data.to_yaml)
+      path = global_config_path
+      dir = File.dirname(path)
+      FileUtils.mkdir_p(dir)
+      File.open(path, File::WRONLY | File::CREAT | File::TRUNC, 0o600) do |f|
+        f.write(data.to_yaml)
+      end
+      File.chmod(0o600, path) if File.exist?(path)
     rescue Errno::EACCES, Errno::EROFS, Errno::ENOSPC => e
-      raise ConfigError, "global config at #{global_config_path} could not be written: #{e.message}"
+      raise ConfigError, "global config at #{path} could not be written: #{e.message}"
+    end
+
+    # Registry normalization for the .hive rename (plan U2): rows recorded
+    # with the legacy `…/.hive-state` keep loading; when the recorded tree
+    # no longer exists but a sibling `.hive/` does (or neither exists), the
+    # path is re-resolved against the two-root probe so readers never miss
+    # an upgraded tree.
+    def normalize_registry_state_path(abs_path, recorded)
+      return File.join(abs_path, ProjectDirs.resolve(abs_path)) if recorded.nil? || recorded.to_s.empty?
+
+      expanded = File.expand_path(recorded)
+      if File.directory?(expanded)
+        Hive.announce_legacy_project_dir!(expanded) if File.basename(expanded) == LEGACY_PROJECT_DIR
+        return expanded
+      end
+
+      File.join(abs_path, ProjectDirs.resolve(abs_path))
     end
 
     def find_project(name)
@@ -327,7 +401,7 @@ module Hive
     end
 
     # Load and validate the global `daemon` block from
-    # `~/Dev/hive/config.yml`. Returns the merged Hash (operator
+    # `~/.config/hive/config.yml`. Returns the merged Hash (operator
     # overrides on top of `Config::DEFAULTS["daemon"]`). Used by
     # `hive daemon start` / `reload` so operator knobs in the global
     # config (max_concurrent_runs, poll_interval_sec, log_*, etc.)
@@ -355,7 +429,7 @@ module Hive
       merged
     end
 
-    # Load and validate the global `bot` block from ~/Dev/hive/config.yml.
+    # Load and validate the global `bot` block from ~/.config/hive/config.yml.
     # `require_runtime: true` is used by `hive bot start` so the opt-in
     # credentials fail loudly there without making read-only commands like
     # `hive status` require a Telegram token.
@@ -386,9 +460,9 @@ module Hive
 
     def global_bot_defaults
       defaults = deep_dup(DEFAULTS["bot"])
-      defaults["pid_file"] = File.join(hive_home, ".bot.pid")
-      defaults["log_file"] = File.join(hive_home, "logs", "bot.log")
-      defaults["last_seen_state_file"] = File.join(hive_home, ".bot.last_seen_update_id")
+      defaults["pid_file"] = Hive::Paths.bot_pid_file
+      defaults["log_file"] = Hive::Paths.bot_log_file
+      defaults["last_seen_state_file"] = Hive::Paths.bot_last_seen_file
       defaults
     end
 
@@ -401,7 +475,9 @@ module Hive
       end
       data["registered_projects"] ||= []
       abs_path = File.expand_path(path)
-      hive_state_path = File.join(abs_path, ".hive-state")
+      # Record the canonical scaffold root; the two-root resolver keeps
+      # legacy rows loadable (plan U2 back-compat).
+      hive_state_path = File.join(abs_path, ProjectDirs.resolve(abs_path))
       entry = { "name" => name, "path" => abs_path, "hive_state_path" => hive_state_path }
       existing = data["registered_projects"].find { |p| p["name"] == name }
       if existing
@@ -577,6 +653,7 @@ module Hive
       daemon
       bot
       rebase
+      models
     ].freeze
 
     def validate_hash_shaped_keys!(cfg, source_path)
diff --git a/lib/hive/daemon/child_supervisor.rb b/lib/hive/daemon/child_supervisor.rb
index fd87d15..083bbd7 100644
--- a/lib/hive/daemon/child_supervisor.rb
+++ b/lib/hive/daemon/child_supervisor.rb
@@ -73,7 +73,7 @@ module Hive
         FileUtils.mkdir_p(File.dirname(log_path))
         # Open with truncation ("w") so each child run starts a fresh
         # per-task log; logs from prior runs are not preserved here —
-        # the daemon's own log file at ~/Dev/hive/logs/daemon.log
+        # the daemon's own log file at ~/.local/state/hive/logs/daemon.log
         # carries the cross-run history.
         log_io = File.open(log_path, "w")
         log_io.puts("[hive-daemon] #{Time.now.utc.iso8601} spawn argv=#{argv.inspect}")
diff --git a/lib/hive/daemon/dispatcher.rb b/lib/hive/daemon/dispatcher.rb
index 4f6d345..4d38516 100644
--- a/lib/hive/daemon/dispatcher.rb
+++ b/lib/hive/daemon/dispatcher.rb
@@ -513,7 +513,7 @@ module Hive
       end
 
       def reload_config!
-        # PR-40 review P1 #2: rebase on the global ~/Dev/hive/config.yml's
+        # PR-40 review P1 #2: rebase on the global ~/.config/hive/config.yml's
         # daemon block, not bare DEFAULTS.
         @daemon_cfg = Hive::Config.load_global_daemon
         @config = { "daemon" => @daemon_cfg }
